VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsRegistry"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'
'  Nibbles fr Windows
'
'  Copyright (C) 2000-2001 by Herfried K. Wagner.
'  Alle Rechte vorbehalten.
'
'  Sie sind berechtigt, die Anwendung in unvernderter Form zu kompilieren und im Eigengebrauch
'  zu verwenden, es wird dafr aber keine Haftung bernommen. Sie sind nicht berechtigt, den
'  Code in eigenen Programmen zu verwenden, ausser Sie holen sich vorher die schriftliche
'  Genehmigung des Autors ein. Weiters sind Sie nicht berechtigt, nderungen am Code vorzunehmen,
'  ausser diese dienen *nur* zum Eigengebrauch. Das Entfernen der Copyright-Hinweise ist nicht
'  gestattet. Ebenso darf das Programm bzw. Teile davon nicht auf Server geladen werden, auch die
'  Weitergabe des Codes ist nicht gestattet, es muss immer auf eine der folgenden Adressen
'  verwiesen werden:
'
'    http://www.ActiveVB.de
'    http://www.vbFun.de
'    http://beam.to/hirfhome
'
'  Bei Kommentaren, Fehlern oder Anregungen richten Sie bitte ein e-Mail an Hirf@ActiveVB.de.
'  Ich wnsche viel Spass mit diesem kleinen Spielchen ;-)
'
'
' Win32 API Registry Access.
'
' Einige der Funktionen geben einen Long-Wert zurck, der Aufschluss ber den Erfolg der Operation
' gibt. Ist der Rckgabewert 0, dann war die Operation erfolgreich, andernfalls ist ein Fehler
' aufgetreten.
'
Option Explicit

' Registry Sections.
Public Enum RegSections
    HKEY_CLASSES_ROOT = 0
    HKEY_CURRENT_USER = 1
    HKEY_LOCAL_MACHINE = 2
    HKEY_USERS = 3
    HKEY_PERFORMANCE_DATA = 4   ' NT only.
    HKEY_CURRENT_CONFIG = 5
    HKEY_DYN_DATA = 6
End Enum

' Used to check if there was an error.
Private Const ERROR_SUCCESS = 0

' Main key.
Private Const MAIN_KEY = &H80000000

' Access codes.
Private Const KEY_ALL_ACCESS = &H3F

Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8

' Optionen beim Anlegen.
Private Const REG_OPTION_NON_VOLATILE = 0

' Datentypen.
Private Const REG_NONE = 0
Private Const REG_SZ = 1
Private Const REG_EXPAND_SZ = 2
Private Const REG_BINARY = 3
Private Const REG_DWORD = 4
Private Const REG_DWORD_LITTLE_ENDIAN = 4
Private Const REG_DWORD_BIG_ENDIAN = 5
Private Const REG_LINK = 6
Private Const REG_MULTI_SZ = 7
Private Const REG_RESOURCE_LIST = 8
Private Const REG_FULL_RESOURCE_DESCRIPTOR = 9
Private Const REG_RESOURCE_REQUIREMENTS_LIST = 10

' Structures.
Private Type Time
    LowTime As Long
    HighTime As Long
End Type

' Sicherheitsstruktur nur zur Deklaration der Funktionen.
Private Type SECURITY_ATTRIBUTES
    Length As Long
    Descriptor As Long
    InheritHandle As Boolean
End Type

Private Declare Function RegOpenKeyEx Lib "advapi32" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal sSubKey As String, ByVal lReserved As Long, ByVal lSecurity As Long, hKeyReturn As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32" (ByVal hKey As Long) As Long

Private Declare Function RegQueryValue Lib "advapi32" Alias "RegQueryValueA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal lpValue As String, lpcbValue As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal sValue As String, lReserved As Long, lTyp&, ByVal sData As String, lcbData As Long) As Long
Private Declare Function RegQueryValueExString Lib "advapi32" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Private Declare Function RegQueryValueExLong Lib "advapi32" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Long, lpcbData As Long) As Long
Private Declare Function RegQueryValueExNULL Lib "advapi32" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As Long, lpcbData As Long) As Long

Private Declare Function RegEnumKey Lib "advapi32" Alias "RegEnumKeyA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpname As String, ByVal cbName As Long) As Long
Private Declare Function RegEnumKeyEx Lib "advapi32" Alias "RegEnumKeyExA" (ByVal hKey As Long, ByVal SubKeyIndex As Long, ByVal SubKeyName As String, SubKeyNameSize As Long, Reserved As Long, ByVal Class As String, ClassSize As Long, FileTime As Time) As Long

Private Declare Function RegSetValueEx Lib "advapi32" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal Name As String, ByVal Reserved As Long, ByVal DataType As Long, ByVal Data As String, ByVal Length As Long) As Long
Private Declare Function RegCreateKeyEx Lib "advapi32" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal SubKey As String, ByVal Reserved As Long, ByVal Class As String, ByVal Options As Long, ByVal Access As Long, Security As SECURITY_ATTRIBUTES, hKeyNew As Long, Disposition As Long) As Long

Private Declare Function RegDeleteValue Lib "advapi32" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal Key As String) As Long
Private Declare Function RegDeleteKey Lib "advapi32" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long

Public Enum RegType
    rtString = REG_SZ
    rtDWord = REG_DWORD
    rtBinary = REG_BINARY
    rtUnknown = -1
End Enum

Public Sub RegCreate(ByVal lngMainKey As Long, ByVal strKey As String)
    Dim strTemp1 As String, strTemp2 As String
    
    Do While InStr(strKey, "\")
        strTemp2 = NextString(strKey, "\")
        Call RegCreateKey(lngMainKey, strTemp1, strTemp2)
        If Len(strTemp1) > 0 Then strTemp1 = strTemp1 & "\"
        strTemp1 = strTemp1 & strTemp2
    Loop
    Call RegCreateKey(lngMainKey, strTemp1, strKey)
End Sub

'
' Possible values for lngKeyIndex:
'
'   0  -  HKEY_CLASSES_ROOT
'   1  -  HKEY_CURRENT_USER
'   2  -  HKEY_LOCAL_MACHINE
'   3  -  HKEY_USERS
'   4  -  HKEY_PERFORMANCE_DATA  (NT only)
'   5  -  HKEY_CURRENT_CONFIG
'   6  -  HKEY_DYN_DATA
'
Public Function RegSetValue(ByVal lngKeyIndex As Long, ByRef strSubKey As String, ByRef strName As String, ByVal lngType As Long, ByRef strValue As String, ByVal lngByte As Long) As Long
    Dim lnghKeyOpen As Long
    
    RegSetValue = RegOpenKeyEx(MAIN_KEY Or lngKeyIndex, strSubKey, 0&, KEY_SET_VALUE, lnghKeyOpen)
    If RegSetValue <> ERROR_SUCCESS Then Exit Function
    RegSetValue = RegSetValueEx(lnghKeyOpen, strName, 0&, lngType, strValue, lngByte)
    Call RegCloseKey(lnghKeyOpen)
End Function

Public Function RegDelValue(ByVal lngKeyIndex As Long, ByRef strKey As String, ByRef strValue As String) As Long
    Dim lnghKeyOpen As Long
    
    RegDelValue = RegOpenKeyEx(MAIN_KEY Or lngKeyIndex, strKey, 0&, KEY_SET_VALUE, lnghKeyOpen)
    If RegDelValue <> ERROR_SUCCESS Then Exit Function
    RegDelValue = RegDeleteValue(lnghKeyOpen, strValue)
    Call RegCloseKey(lnghKeyOpen)
End Function

Public Function RegDelKey(ByVal lngKeyIndex As Integer, ByRef strKey As String) As Long
    RegDelKey = RegDeleteKey(MAIN_KEY Or lngKeyIndex, strKey)
End Function

Public Function RegExistKey(ByVal lngKeyIndex As Long, ByRef strSubKey As String) As Boolean
    Dim lnghKeyOpen As Long, lngResult As Long
    
    lngResult = RegOpenKeyEx(MAIN_KEY Or lngKeyIndex, strSubKey, 0&, KEY_ALL_ACCESS, lnghKeyOpen)
    
    ' Schlssel existiert nicht
    If lngResult <> ERROR_SUCCESS Then
        RegExistKey = False
    Else
        RegExistKey = True
    End If
End Function

Public Function RegExistValue(ByVal lngKeyIndex As Long, ByRef strSubKey As String, ByRef strName As String) As Boolean
    Dim lnghKeyOpen As Long, lngResult As Long, lngType As Long, lngCch As Long
    
    lngResult = RegOpenKeyEx(MAIN_KEY Or lngKeyIndex, strSubKey, 0&, KEY_ALL_ACCESS, lnghKeyOpen)
    
    RegExistValue = False
    
    ' Schlssel existiert nicht
    If lngResult <> ERROR_SUCCESS Then Exit Function
    
    ' Wert existiert nicht
    lngResult = RegQueryValueExNULL(lnghKeyOpen, strName, 0&, lngType, 0&, lngCch)
    If lngResult <> ERROR_SUCCESS Then Exit Function
    
    RegExistValue = True
End Function

Public Function RegGetValueType(ByVal lngKeyIndex As Long, ByRef strSubKey As String, ByRef strName As String) As RegType
    Dim lnghKeyOpen As Long, lngResult As Long, lngType As Long, lngCch As Long
    
    RegGetValueType = rtUnknown
    
    lngResult = RegOpenKeyEx(MAIN_KEY Or lngKeyIndex, strSubKey, 0&, KEY_ALL_ACCESS, lnghKeyOpen)
    If lngResult <> ERROR_SUCCESS Then Exit Function
    
    lngResult = RegQueryValueExNULL(lnghKeyOpen, strName, 0&, lngType, 0&, lngCch)
    If lngResult <> ERROR_SUCCESS Then Exit Function
    
    Select Case lngType
        Case REG_SZ:        RegGetValueType = rtString
        Case REG_DWORD:     RegGetValueType = rtDWord
        Case REG_BINARY:    RegGetValueType = rtBinary
        Case Else:          RegGetValueType = rtBinary
    End Select
End Function

Public Function RegGetValue(ByVal lngKeyIndex As Long, ByRef strSubKey As String, ByRef strName As String) As String
    Dim lnghKeyOpen As Long, lngResult As Long, lngType As Long, lngCch As Long
    Dim strValue As String, lngValue As Long, i As Integer, intCharCode As Integer
    Dim strTemp As String, strBinString As String
    
    lngResult = RegOpenKeyEx(MAIN_KEY Or lngKeyIndex, strSubKey, 0&, KEY_ALL_ACCESS, lnghKeyOpen)
    If lngResult <> ERROR_SUCCESS Then Exit Function
    
    lngResult = RegQueryValueExNULL(lnghKeyOpen, strName, 0&, lngType, 0&, lngCch)
    If lngResult <> ERROR_SUCCESS Then Exit Function
    
    Select Case lngType
        Case REG_SZ
            strValue = String$(lngCch + 1, 0)
            lngResult = RegQueryValueExString(lnghKeyOpen, strName, 0&, lngType, strValue, lngCch)
            If lngResult <> ERROR_SUCCESS Then Exit Function
            
            RegGetValue = NextString(Left$(strValue, lngCch), Chr$(0))
        Case REG_DWORD
            lngResult = RegQueryValueExLong(lnghKeyOpen, strName, 0&, lngType, lngValue, lngCch)
            If lngResult <> ERROR_SUCCESS Then Exit Function
            
            RegGetValue = Trim$(Str$(lngValue))
        Case REG_BINARY
            strValue = String$(lngCch + 1, 0)
            lngResult = RegQueryValueExString(lnghKeyOpen, strName, 0&, lngType, strValue, lngCch)
            If lngResult <> ERROR_SUCCESS Then Exit Function
            
            RegGetValue = Left$(strValue, lngCch)
            For i = 1 To Len(RegGetValue)
                intCharCode = Asc(Mid$(RegGetValue, i, 1))
                
                ' Binrwerte bringen Probleme, sollte so aber funktionieren.
                strTemp = ""
                If intCharCode = 26 Then strTemp = "1A "
                If intCharCode = 58 Then strTemp = "3A "
                If intCharCode = 74 Then strTemp = "4A "
                If intCharCode = 90 Then strTemp = "5A "
                If intCharCode = 106 Then strTemp = "6A "
                If intCharCode = 122 Then strTemp = "7A "
                If intCharCode = 138 Then strTemp = "8A "
                If intCharCode = 154 Then strTemp = "9A "
                If Len(strTemp) = 0 Then
                    strBinString = strBinString & Format$(Hex$(Asc(Mid$(RegGetValue, i, 1))), "00") & " "
                Else
                    strBinString = strBinString & strTemp
                End If
            Next i
            RegGetValue = strBinString
    End Select
    
    Call RegCloseKey(lnghKeyOpen)
End Function

'
' Note that strSearchIn is a ByRef parameter.
'
Private Function NextString(ByRef strSearchIn As String, ByRef strSearchFor As String) As String
    Dim intFoundAt As Integer
    
    intFoundAt = InStr(strSearchIn, strSearchFor)
    If intFoundAt = 0 Then
        NextString = strSearchIn
        strSearchIn = ""
    Else
        NextString = Left$(strSearchIn, intFoundAt - 1)
        strSearchIn = Mid$(strSearchIn, intFoundAt + Len(strSearchFor))
    End If
End Function

Public Function RegCreateKey(ByVal lngKeyIndex As Long, ByRef strSubKey As String, ByRef strNewSubKey As String) As Long
    Dim lnghKeyOpen As Long, lnghKeyNew As Long, lngDisposition As Long
    Dim saSecurity As SECURITY_ATTRIBUTES
    
    RegCreateKey = RegOpenKeyEx(MAIN_KEY Or lngKeyIndex, strSubKey, 0&, KEY_CREATE_SUB_KEY, lnghKeyOpen)
    If RegCreateKey <> ERROR_SUCCESS Then Exit Function
    
    RegCreateKey = RegCreateKeyEx(lnghKeyOpen, strNewSubKey, 0&, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, saSecurity, lnghKeyNew, lngDisposition)
    If RegCreateKey = ERROR_SUCCESS Then
        'If lngDisposition = REG_CREATED_NEW_KEY Then
            ' ... Key was created.
        'Else
            ' ... Key already exists.
        'End If
        Call RegCloseKey(lnghKeyNew)
    End If
    
    Call RegCloseKey(lnghKeyOpen)
End Function

Public Sub RegSetBinary(ByVal lngMainKey As Long, ByRef strKey As String, ByRef strKeyName As String, ByRef strValue As String)
    Call RegCreate(lngMainKey, strKey)
    Call RegSetValue(lngMainKey, strKey, strKeyName, REG_BINARY, strValue, Len(strValue))
End Sub

Public Sub RegSetDWord(ByVal lngMainKey As Long, ByRef strKey As String, ByRef strKeyName As String, ByVal lngValue As Long)
    Call RegCreate(lngMainKey, strKey)
    
    Dim strTempVal As String, i As Integer
    
    For i = 1 To Len(lngValue)
        strTempVal = strTempVal & Chr$(lngValue Mod 256)
        lngValue = Int(lngValue / 256)
    Next i
    
    Call RegSetValue(lngMainKey, strKey, strKeyName, REG_DWORD, strTempVal, Len(lngValue))
End Sub

Public Sub RegSetString(ByVal lngMainKey As Long, ByRef strKey As String, ByRef strKeyName As String, ByRef strValue As String)
    Call RegCreate(lngMainKey, strKey)
    Call RegSetValue(lngMainKey, strKey, strKeyName, REG_SZ, strValue, Len(strValue))
End Sub
