Attribute VB_Name = "modGame"
'
'  Nibbles fr Windows
'
'  Copyright (C) 2000-2001 by Herfried K. Wagner.
'  Alle Rechte vorbehalten.
'
'  Sie sind berechtigt, die Anwendung in unvernderter Form zu kompilieren und im Eigengebrauch
'  zu verwenden, es wird dafr aber keine Haftung bernommen. Sie sind nicht berechtigt, den
'  Code in eigenen Programmen zu verwenden, ausser Sie holen sich vorher die schriftliche
'  Genehmigung des Autors ein. Weiters sind Sie nicht berechtigt, nderungen am Code vorzunehmen,
'  ausser diese dienen *nur* zum Eigengebrauch. Das Entfernen der Copyright-Hinweise ist nicht
'  gestattet. Ebenso darf das Programm bzw. Teile davon nicht auf Server geladen werden, auch die
'  Weitergabe des Codes ist nicht gestattet, es muss immer auf eine der folgenden Adressen
'  verwiesen werden:
'
'    http://www.ActiveVB.de
'    http://www.vbFun.de
'    http://beam.to/hirfhome
'
'  Bei Kommentaren, Fehlern oder Anregungen richten Sie bitte ein e-Mail an Hirf@ActiveVB.de.
'  Ich wnsche viel Spass mit diesem kleinen Spielchen ;-)
'
'**************************************************************************************************
'
'  Global game functions.
'
'**************************************************************************************************
Option Explicit

'*************************************
' Public Variables and Constants.
'*************************************
                                            '**************************************
' Field size (length units).                ' Total   Without border (real size). '
Public Const g_conSizeX As Integer = 48     '  49      47                         '
Public Const g_conSizeY As Integer = 36     '  37      35                         '
                                            '**************************************
' //-->

' The Worm(s).
Public g_clsWorms() As New clsWorm

' Type used for unit description.
Public Type Unit
    blnIsWall As Boolean        ' Determines if the unit is a wall.
    intWormOver As Integer      ' The number of the worm who occupies this unit.
End Type

' The playing field. We use a 2 dimensional matrix to store the information for each field.
Public g_unPlayingField(0 To g_conSizeX, 0 To g_conSizeY) As Unit

' <--//

Public g_intNumFood As Integer
Public g_intLengthUnit As Integer   ' Length unit based in block width.
Public g_intLevel As Integer        ' Level.
Public g_intNumPlayers As Integer   ' Number of players (1 or 2).

' Directions.
Public Enum Direction
    dirLeft = 0
    dirDown = 1
    dirRight = 2
    dirUp = 3
End Enum

' Position of the food.
Public g_intFoodLeft As Integer
Public g_intFoodTop As Integer

' Number of levels.
Public Const g_conIntNumLevels As Integer = 10

' Control Keys.
Public Type ControlKeys
    intLeft As Integer
    intUp As Integer
    intRight As Integer
    intDown As Integer
End Type

' Keytables used for player 1 and player 2.
Public g_ckControlKeys(0 To 1) As ControlKeys

' Public vars to hold registry data.
Public g_blnUseSound As Boolean         ' Play waves.
Public g_intSpeed As Integer            ' Speed.
Public g_strPlayerName1 As String       ' Player1 Name.
Public g_strPlayerName2 As String       ' Player2 Name.
Public g_blnSinglePlayer As Boolean     ' Single Player Mode.

Public g_blnSmallMode As Boolean        ' Gibt an, ob das Spiel auf einer Auflsung <= 600 x 800 Pixel
                                        ' ausgefhrt wird.

' HighScores.
Public g_clsScores As New clsHighScore
Public g_clsRegistry As New clsRegistry

Public Sub AddToScores()
    If g_intNumPlayers = 1 Then
        Call g_clsScores.InsertScores(g_clsWorms(1).PlayerName, g_clsWorms(1).Score)
    Else
        Call g_clsScores.InsertScores(g_clsWorms(1).PlayerName, g_clsWorms(1).Score)
        Call g_clsScores.InsertScores(g_clsWorms(2).PlayerName, g_clsWorms(2).Score)
    End If
End Sub

Public Sub ResetRound()
    
    ' If we have 2 players then we do not reset...
    If g_clsWorms(1).GameOver Then
        If g_intNumPlayers = 2 Then
            If g_clsWorms(2).GameOver Then Exit Sub
        End If
    End If
    
    Call RemoveMessage
    
    ' Clear the background.
    frmMain.picField.Cls
    
    If g_clsWorms(1).GameOver = False Then Call g_clsWorms(1).Reset
    If g_intNumPlayers = 2 Then
        If g_clsWorms(2).GameOver = False Then Call g_clsWorms(2).Reset
    End If
    
    ' Paint the walls.
    Call PaintWalls
    
    ' Place first food.
    g_intNumFood = 0
    Call ShowNextFood
    
    #If UseVBTimer Then
        frmMain.tmrTimer.Enabled = True     ' ***
    #Else
        Call EnableTimer
    #End If
End Sub

'
' Called when the worms crash.
'
Public Sub WormCrash()
    g_clsWorms(1).Lives = g_clsWorms(1).Lives - 1
    g_clsWorms(2).Lives = g_clsWorms(2).Lives - 1
    
    If g_clsWorms(1).GameOver And g_clsWorms(2).GameOver Then
        Dim strResultText As String
        
        If g_intNumPlayers = 2 Then
            If g_clsWorms(1).Score > g_clsWorms(2).Score Then
                strResultText = g_clsWorms(1).PlayerName & " hat gewonnen!"
            ElseIf g_clsWorms(2).Score > g_clsWorms(1).Score Then
                strResultText = g_clsWorms(2).PlayerName & " hat gewonnen!"
            Else
                strResultText = "Unentschieden"
            End If
        End If
        Call AddToScores
        
        Call DisplayMessage("Game Over", strResultText)
    End If
End Sub

'
' Neues Spiel starten.
'
Public Sub NewGame()
    g_intLevel = 0
    
    g_clsWorms(1).InitWorm
    If g_intNumPlayers = 2 Then g_clsWorms(2).InitWorm
    
    Call NextLevel
    Call ResetRound
End Sub

'
' Show next food. Do NOT place it over a worm or over a wall.
'
Public Sub ShowNextFood()
    Dim intRandX As Integer, intRandY As Integer
    
GetNewPos:
    intRandX = Int((g_conSizeX) * Rnd)
    intRandY = Int((g_conSizeY) * Rnd)
    
    If _
        g_unPlayingField(intRandX, intRandY).intWormOver <> 0 Or _
        g_unPlayingField(intRandX, intRandY).blnIsWall _
    Then
        GoTo GetNewPos
    End If
    
    g_intFoodLeft = intRandX
    g_intFoodTop = intRandY
    
    Call PlaceFood(g_intFoodLeft, g_intFoodTop)
    
    frmMain.lblNumFood.Caption = Format$(g_intNumFood + 1, "00")
End Sub

'
' Food.
'
Public Function PlaceFood(ByVal lngLeft As Long, ByVal lngTop As Long) As Long
    Dim strNumFood As String
    
    frmMain.picFood.Cls
    
    strNumFood = CStr(g_intNumFood + 1)
    Call TextOut(frmMain.picFood.hdc, frmMain.picFood.ScaleWidth / 2 - frmMain.picFood.TextWidth(strNumFood) / 2, frmMain.picFood.ScaleHeight / 2 - frmMain.picFood.TextHeight(strNumFood) / 2, strNumFood, Len(strNumFood))
    
    PlaceFood = BitBlt(frmMain.picField.hdc, lngLeft * g_intLengthUnit, lngTop * g_intLengthUnit, 2 * g_intLengthUnit, 2 * g_intLengthUnit, frmMain.picFood.hdc, 0, 0, SRCCOPY)
End Function

Public Function RemoveFood() As Long
    RemoveFood = BitBlt(frmMain.picField.hdc, g_intFoodLeft * g_intLengthUnit, g_intFoodTop * g_intLengthUnit, g_intLengthUnit, g_intLengthUnit, frmMain.picRemove.hdc, 0, 0, SRCCOPY)
End Function

'
' Display the game message PictureBox.
'
Public Sub DisplayMessage(strTitle As String, strText As String)
    frmMain.picField.Refresh
    frmMain.lblMsgTitle.Caption = strTitle
    frmMain.lblMsgText.Caption = strText
    #If UseVBTimer Then
        frmMain.tmrTimer.Enabled = False
    #Else
        Call DisableTimer
    #End If
    frmMain.picMessage.Visible = True
End Sub

'
' Remove game message.
'
Public Sub RemoveMessage()
    frmMain.picMessage.Visible = False
End Sub

'
' Zeichnet die Mauern fr ein angegebenes Level.
'
Public Sub PaintWalls()
    Dim i As Integer, j As Integer
    
    For i = 0 To g_conSizeX
        For j = 0 To g_conSizeY
            If g_unPlayingField(i, j).blnIsWall Then Call BitBlt(frmMain.picField.hdc, i * g_intLengthUnit, j * g_intLengthUnit, g_intLengthUnit, g_intLengthUnit, frmMain.picWall.hdc, 0, 0, SRCCOPY)
        Next j
    Next i
End Sub

'
' This sub is only used to draw the graphical rect around the playing field *before* the game starts.
'
Public Sub PaintBorder()
    Dim i As Integer
    
    For i = 1 To 35
        Call BitBlt(frmMain.picField.hdc, 0 * g_intLengthUnit, i * g_intLengthUnit, g_intLengthUnit, g_intLengthUnit, frmMain.picWall.hdc, 0, 0, SRCCOPY)
        Call BitBlt(frmMain.picField.hdc, 48 * g_intLengthUnit, i * g_intLengthUnit, g_intLengthUnit, g_intLengthUnit, frmMain.picWall.hdc, 0, 0, SRCCOPY)
    Next i
    For i = 0 To 48
        Call BitBlt(frmMain.picField.hdc, i * g_intLengthUnit, 0 * g_intLengthUnit, g_intLengthUnit, g_intLengthUnit, frmMain.picWall.hdc, 0, 0, SRCCOPY)
        Call BitBlt(frmMain.picField.hdc, i * g_intLengthUnit, 36 * g_intLengthUnit, g_intLengthUnit, g_intLengthUnit, frmMain.picWall.hdc, 0, 0, SRCCOPY)
    Next i
End Sub

'
' Initializes data for the level.
'
'   -  Sets the worm's starting positions.
'   -  Removes data from former levels (only walls, not worms).
'   -  Prepares new walls.
'
Public Sub SelectWalls()
    Dim i As Integer, j As Integer
    
    ' Reset all fields and create a wall around the field.
    For i = 0 To g_conSizeX
        For j = 0 To g_conSizeY
            If i = 0 Or i = g_conSizeX Then
                g_unPlayingField(i, j).blnIsWall = True
            Else
                If j = 0 Or j = g_conSizeY Then
                    g_unPlayingField(i, j).blnIsWall = True
                Else
                    g_unPlayingField(i, j).blnIsWall = False
                End If
            End If
        Next j
    Next i
    
    ' Initialize level-specific data (starting positions and onther walls).
    Select Case g_intLevel
        Case 1
            If g_intNumPlayers = 1 Then
                Call g_clsWorms(1).SetWormStartPos(24, 18, dirRight)
            ElseIf g_intNumPlayers = 2 Then
                Call g_clsWorms(1).SetWormStartPos(24, 16, dirRight)
                Call g_clsWorms(2).SetWormStartPos(24, 20, dirLeft)
            End If
        Case 2
            Call g_clsWorms(1).SetWormStartPos(24, 9, dirRight)
            If g_intNumPlayers = 2 Then Call g_clsWorms(2).SetWormStartPos(24, 27, dirLeft)
            
            For i = 13 To 35
                g_unPlayingField(i, 18).blnIsWall = True
            Next i
        Case 3
            If g_intNumPlayers = 1 Then
                Call g_clsWorms(1).SetWormStartPos(24, 10, dirDown)
            ElseIf g_intNumPlayers = 2 Then
                Call g_clsWorms(1).SetWormStartPos(22, 10, dirDown)
                Call g_clsWorms(2).SetWormStartPos(26, 26, dirUp)
            End If
            
            For i = 11 To 25
                g_unPlayingField(14, i).blnIsWall = True
                g_unPlayingField(34, i).blnIsWall = True
            Next i
        Case 4
            If g_intNumPlayers = 1 Then
                Call g_clsWorms(1).SetWormStartPos(10, 18, dirRight)
            ElseIf g_intNumPlayers = 2 Then
                Call g_clsWorms(1).SetWormStartPos(10, 9, dirRight)
                Call g_clsWorms(2).SetWormStartPos(38, 27, dirLeft)
            End If
            
            For i = 1 To g_conSizeY
                If i Mod 3 <> 0 Then g_unPlayingField(24, i).blnIsWall = True
            Next i
        Case 5
            Call g_clsWorms(1).SetWormStartPos(10, 6, dirRight)
            If g_intNumPlayers = 2 Then Call g_clsWorms(2).SetWormStartPos(38, 30, dirLeft)
            
            For i = 16 To 31
                g_unPlayingField(i + 1, 9).blnIsWall = True
                g_unPlayingField(i, 27).blnIsWall = True
            Next i
            For i = 10 To 25
                g_unPlayingField(15, i).blnIsWall = True
                g_unPlayingField(33, i + 1).blnIsWall = True
            Next i
        Case 6
            Call g_clsWorms(1).SetWormStartPos(15, 7, dirDown)
            If g_intNumPlayers = 2 Then Call g_clsWorms(2).SetWormStartPos(33, 29, dirUp)
            
            For i = 6 To 42 Step 12
                For j = 1 To 30
                    g_unPlayingField(i, j).blnIsWall = True
                Next j
                For j = 6 To 36
                    g_unPlayingField(i + 6, j).blnIsWall = True
                Next j
            Next i
        Case 7
            If g_intNumPlayers = 1 Then
                Call g_clsWorms(1).SetWormStartPos(15, 18, dirRight)
            ElseIf g_intNumPlayers = 2 Then
                Call g_clsWorms(1).SetWormStartPos(15, 17, dirRight)
                Call g_clsWorms(2).SetWormStartPos(33, 19, dirLeft)
            End If
            
            For i = 8 To 40 Step 8
                For j = 1 To 14
                    g_unPlayingField(i, j).blnIsWall = True
                Next j
                For j = 22 To 35
                    g_unPlayingField(i, j).blnIsWall = True
                Next j
            Next i
        Case 8
            Call g_clsWorms(1).SetWormStartPos(10, 26, dirRight)
            If g_intNumPlayers = 2 Then Call g_clsWorms(2).SetWormStartPos(38, 10, dirLeft)
            
            For i = 1 To 33
                g_unPlayingField(i + 7, i + 1).blnIsWall = True
            Next i
        Case 9
            If g_intNumPlayers = 1 Then
                Call g_clsWorms(1).SetWormStartPos(10, 18, dirRight)
            ElseIf g_intNumPlayers = 2 Then
                Call g_clsWorms(1).SetWormStartPos(10, 26, dirRight)
                Call g_clsWorms(2).SetWormStartPos(38, 11, dirLeft)
            End If
            
            For i = 1 To 35 Step 2
                g_unPlayingField(16, i).blnIsWall = True
                g_unPlayingField(32, i + 1).blnIsWall = True
            Next i
        Case 10
            If g_intNumPlayers = 1 Then
                Call g_clsWorms(1).SetWormStartPos(24, 30, dirUp)
            ElseIf g_intNumPlayers = 2 Then
                Call g_clsWorms(1).SetWormStartPos(22, 6, dirDown)
                Call g_clsWorms(2).SetWormStartPos(26, 6, dirDown)
            End If
            
            g_unPlayingField(16, 23).blnIsWall = True
            g_unPlayingField(32, 23).blnIsWall = True
            For i = 19 To 23
                g_unPlayingField(i, 21).blnIsWall = True
                g_unPlayingField(i + 6, 21).blnIsWall = True
            Next i
            g_unPlayingField(17, 22).blnIsWall = True
            g_unPlayingField(18, 22).blnIsWall = True
            g_unPlayingField(30, 22).blnIsWall = True
            g_unPlayingField(31, 22).blnIsWall = True
            For i = 1 To 20
                g_unPlayingField(i, 17).blnIsWall = True
            Next i
            For i = 28 To 47
                g_unPlayingField(i, 17).blnIsWall = True
            Next i
            For i = 1 To 13
                g_unPlayingField(24, i).blnIsWall = True
            Next i
            For i = 26 To 35
                g_unPlayingField(14, i).blnIsWall = True
                g_unPlayingField(34, i).blnIsWall = True
            Next i
            g_unPlayingField(15, 24).blnIsWall = True
            g_unPlayingField(15, 25).blnIsWall = True
            g_unPlayingField(33, 24).blnIsWall = True
            g_unPlayingField(33, 25).blnIsWall = True
    End Select
End Sub

'
' Initialisiert Daten/Steuerelemente fr das nchste Level.
'
Public Sub NextLevel()
    g_intLevel = g_intLevel + 1
    Call SelectWalls
    
    Dim i As Integer, j As Integer
    
    ' Remove the worms.
    For i = 0 To g_conSizeX
        For j = 0 To g_conSizeY
            g_unPlayingField(i, j).intWormOver = 0
        Next j
    Next i
    
    If g_clsWorms(1).GameOver = False Then Call g_clsWorms(1).ShowInitWorm
    If g_intNumPlayers = 2 Then
        If g_clsWorms(2).GameOver = False Then Call g_clsWorms(2).ShowInitWorm
    End If
    
    frmMain.lblLevel.Caption = Format$(g_intLevel, "00")
    
    Call ResetRound
End Sub

Public Sub Crash()
    frmMain.picField.Refresh
    
    If frmMain.mnuGameSound.Checked = True Then Call PlayWaveResource("wallhit")
    
    If g_clsWorms(1).Lives = 0 Then g_clsWorms(1).GameOver = True
    If g_intNumPlayers = 2 Then
        If g_clsWorms(2).Lives = 0 Then g_clsWorms(2).GameOver = True
    End If
    
    If g_intNumPlayers = 1 And g_clsWorms(1).GameOver = True Then GoTo GameOver
    If g_intNumPlayers = 2 Then
        If g_clsWorms(1).GameOver = True And g_clsWorms(2).GameOver = True Then
            GoTo GameOver
        End If
    End If
    
    If g_intNumPlayers = 1 And g_clsWorms(1).Dead = True Then Call ResetRound
    If g_intNumPlayers = 2 Then
        If g_clsWorms(1).Dead = True And g_clsWorms(2).Dead = True Then
            Call ResetRound
        End If
    End If
    
    Exit Sub
    
GameOver:
    Dim strWinnerName As String
    
    If g_intNumPlayers = 2 Then
        If g_clsWorms(1).Score > g_clsWorms(2).Score Then
            strWinnerName = g_clsWorms(1).PlayerName & " hat gewonnen!"
        ElseIf g_clsWorms(2).Score > g_clsWorms(1).Score Then
            strWinnerName = g_clsWorms(2).PlayerName & " hat gewonnen!"
        Else
            strWinnerName = "Unentschieden!"
        End If
    Else
        strWinnerName = "Sie haben verloren!"
    End If
    
    ' Check if the values should be added to the HighScores table.
    Call AddToScores
    
    Call DisplayMessage("Game Over", strWinnerName)
End Sub
