Attribute VB_Name = "modSettings"
'
'  Nibbles fr Windows
'
'  Copyright (C) 2000-2001 by Herfried K. Wagner.
'  Alle Rechte vorbehalten.
'
'  Sie sind berechtigt, die Anwendung in unvernderter Form zu kompilieren und im Eigengebrauch
'  zu verwenden, es wird dafr aber keine Haftung bernommen. Sie sind nicht berechtigt, den
'  Code in eigenen Programmen zu verwenden, ausser Sie holen sich vorher die schriftliche
'  Genehmigung des Autors ein. Weiters sind Sie nicht berechtigt, nderungen am Code vorzunehmen,
'  ausser diese dienen *nur* zum Eigengebrauch. Das Entfernen der Copyright-Hinweise ist nicht
'  gestattet. Ebenso darf das Programm bzw. Teile davon nicht auf Server geladen werden, auch die
'  Weitergabe des Codes ist nicht gestattet, es muss immer auf eine der folgenden Adressen
'  verwiesen werden:
'
'    http://www.ActiveVB.de
'    http://www.vbFun.de
'    http://beam.to/hirfhome
'
'  Bei Kommentaren, Fehlern oder Anregungen richten Sie bitte ein e-Mail an Hirf@ActiveVB.de.
'  Ich wnsche viel Spass mit diesem kleinen Spielchen ;-)
'
Option Explicit

' Regsitrierungsschlssel fr die Soundeinstellungen in HKEY_CURRENT_USER.
Private Const m_conRegSubKeyApp As String = "Software\HirfSoft\Nibbles"

'
' Reads game settings from the registry.
'
Public Sub ReadSettings()
    Dim s As String
    
    ' Player1 Sound.
    s = g_clsRegistry.RegGetValue(HKEY_CURRENT_USER, m_conRegSubKeyApp, "Sound")
    If Len(s) = 0 Or Not IsNumeric(s) Then
        frmMain.mnuGameSound.Checked = False
    ElseIf s = "0" Then
        frmMain.mnuGameSound.Checked = False
    ElseIf s = "1" Then
        frmMain.mnuGameSound.Checked = True
    Else
        frmMain.mnuGameSound.Checked = False
    End If
    
    ' Player1 Left.
    s = g_clsRegistry.RegGetValue(HKEY_CURRENT_USER, m_conRegSubKeyApp & "\Player1", "Left")
    If Len(s) = 0 Or Not IsNumeric(s) Then
        g_ckControlKeys(0).intLeft = vbKeyLeft
    Else
        g_ckControlKeys(0).intLeft = CInt(s)
    End If
    
    ' Player1 Right.
    s = g_clsRegistry.RegGetValue(HKEY_CURRENT_USER, m_conRegSubKeyApp & "\Player1", "Right")
    If Len(s) = 0 Or Not IsNumeric(s) Then
        g_ckControlKeys(0).intRight = vbKeyRight
    Else
        g_ckControlKeys(0).intRight = CInt(s)
    End If
    
    ' Player1 Up.
    s = g_clsRegistry.RegGetValue(HKEY_CURRENT_USER, m_conRegSubKeyApp & "\Player1", "Up")
    If Len(s) = 0 Or Not IsNumeric(s) Then
        g_ckControlKeys(0).intUp = vbKeyUp
    Else
        g_ckControlKeys(0).intUp = CInt(s)
    End If
    
    ' Player1 Down.
    s = g_clsRegistry.RegGetValue(HKEY_CURRENT_USER, m_conRegSubKeyApp & "\Player1", "Down")
    If Len(s) = 0 Or Not IsNumeric(s) Then
        g_ckControlKeys(0).intDown = vbKeyDown
    Else
        g_ckControlKeys(0).intDown = CInt(s)
    End If
    
    ' Player2 Left.
    s = g_clsRegistry.RegGetValue(HKEY_CURRENT_USER, m_conRegSubKeyApp & "\Player2", "Left")
    If Len(s) = 0 Or Not IsNumeric(s) Then
        g_ckControlKeys(1).intLeft = vbKeyA
    Else
        g_ckControlKeys(1).intLeft = CInt(s)
    End If
    
    ' Player2 Right.
    s = g_clsRegistry.RegGetValue(HKEY_CURRENT_USER, m_conRegSubKeyApp & "\Player2", "Right")
    If Len(s) = 0 Or Not IsNumeric(s) Then
        g_ckControlKeys(1).intRight = vbKeyD
    Else
        g_ckControlKeys(1).intRight = CInt(s)
    End If
    
    ' Player2 Up.
    s = g_clsRegistry.RegGetValue(HKEY_CURRENT_USER, m_conRegSubKeyApp & "\Player2", "Up")
    If Len(s) = 0 Or Not IsNumeric(s) Then
        g_ckControlKeys(1).intUp = vbKeyW
    Else
        g_ckControlKeys(1).intUp = CInt(s)
    End If
    
    ' Player2 Down.
    s = g_clsRegistry.RegGetValue(HKEY_CURRENT_USER, m_conRegSubKeyApp & "\Player2", "Down")
    If Len(s) = 0 Or Not IsNumeric(s) Then
        g_ckControlKeys(1).intDown = vbKeyS
    Else
        g_ckControlKeys(1).intDown = CInt(s)
    End If
    
    ' Game speed.
    s = g_clsRegistry.RegGetValue(HKEY_CURRENT_USER, m_conRegSubKeyApp, "Speed")
    If Len(s) = 0 Or Not IsNumeric(s) Then
        g_intSpeed = 50
    Else
        g_intSpeed = CInt(s)
    End If
    
    ' SinglePlayer.
    s = g_clsRegistry.RegGetValue(HKEY_CURRENT_USER, m_conRegSubKeyApp, "SinglePlayer")
    If Len(s) = 0 Or Not IsNumeric(s) Then
        g_blnSinglePlayer = False
    ElseIf s = "0" Then
        g_blnSinglePlayer = False
    ElseIf s = "1" Then
        g_blnSinglePlayer = True
    Else
        g_blnSinglePlayer = False
    End If
    
    ' PlayerName1
    s = g_clsRegistry.RegGetValue(HKEY_CURRENT_USER, m_conRegSubKeyApp, "PlayerName1")
    If Len(s) = 0 Then
        g_strPlayerName1 = "Player1"
    Else
        g_strPlayerName1 = s
    End If
    
    ' PlayerName2.
    s = g_clsRegistry.RegGetValue(HKEY_CURRENT_USER, m_conRegSubKeyApp, "PlayerName2")
    If Len(s) = 0 Then
        g_strPlayerName2 = "Player2"
    Else
        g_strPlayerName2 = s
    End If
End Sub

'
' Writes the settings to the registry (called when terminating).
'
Public Sub WriteSettings()
    With g_clsRegistry
        Call .RegSetDWord(HKEY_CURRENT_USER, m_conRegSubKeyApp, "Sound", IIf(frmMain.mnuGameSound.Checked, 1, 0))
        Call .RegSetDWord(HKEY_CURRENT_USER, m_conRegSubKeyApp & "\Player1", "Left", CLng(g_ckControlKeys(0).intLeft))
        Call .RegSetDWord(HKEY_CURRENT_USER, m_conRegSubKeyApp & "\Player1", "Right", CLng(g_ckControlKeys(0).intRight))
        Call .RegSetDWord(HKEY_CURRENT_USER, m_conRegSubKeyApp & "\Player1", "Up", CLng(g_ckControlKeys(0).intUp))
        Call .RegSetDWord(HKEY_CURRENT_USER, m_conRegSubKeyApp & "\Player1", "Down", CLng(g_ckControlKeys(0).intDown))
        Call .RegSetDWord(HKEY_CURRENT_USER, m_conRegSubKeyApp & "\Player2", "Left", CLng(g_ckControlKeys(1).intLeft))
        Call .RegSetDWord(HKEY_CURRENT_USER, m_conRegSubKeyApp & "\Player2", "Right", CLng(g_ckControlKeys(1).intRight))
        Call .RegSetDWord(HKEY_CURRENT_USER, m_conRegSubKeyApp & "\Player2", "Up", CLng(g_ckControlKeys(1).intUp))
        Call .RegSetDWord(HKEY_CURRENT_USER, m_conRegSubKeyApp & "\Player2", "Down", CLng(g_ckControlKeys(1).intDown))
        Call .RegSetDWord(HKEY_CURRENT_USER, m_conRegSubKeyApp, "Speed", CLng(g_intSpeed))
        Call .RegSetDWord(HKEY_CURRENT_USER, m_conRegSubKeyApp, "SinglePlayer", IIf(g_blnSinglePlayer, 1, 0))
        Call .RegSetString(HKEY_CURRENT_USER, m_conRegSubKeyApp, "PlayerName1", g_strPlayerName1)
        Call .RegSetString(HKEY_CURRENT_USER, m_conRegSubKeyApp, "PlayerName2", g_strPlayerName2)
    End With
End Sub
