Attribute VB_Name = "modTimer"
'
'  Nibbles fr Windows
'
'  Copyright (C) 2000-2001 by Herfried K. Wagner.
'  Alle Rechte vorbehalten.
'
'  Sie sind berechtigt, die Anwendung in unvernderter Form zu kompilieren und im Eigengebrauch
'  zu verwenden, es wird dafr aber keine Haftung bernommen. Sie sind nicht berechtigt, den
'  Code in eigenen Programmen zu verwenden, ausser Sie holen sich vorher die schriftliche
'  Genehmigung des Autors ein. Weiters sind Sie nicht berechtigt, nderungen am Code vorzunehmen,
'  ausser diese dienen *nur* zum Eigengebrauch. Das Entfernen der Copyright-Hinweise ist nicht
'  gestattet. Ebenso darf das Programm bzw. Teile davon nicht auf Server geladen werden, auch die
'  Weitergabe des Codes ist nicht gestattet, es muss immer auf eine der folgenden Adressen
'  verwiesen werden:
'
'    http://www.ActiveVB.de
'    http://www.vbFun.de
'    http://beam.to/hirfhome
'
'  Bei Kommentaren, Fehlern oder Anregungen richten Sie bitte ein e-Mail an Hirf@ActiveVB.de.
'  Ich wnsche viel Spass mit diesem kleinen Spielchen ;-)
'
'**************************************************************************************************
'
'  User32 API Timer "replacement".
'
'  Der hier verwendete Timer zeichnet sich durch eine etwas hhere Laufsicherheit und eine hhere
'  Geschwindigkeit aus.
'
'**************************************************************************************************
Option Explicit

#If Not UseVBTimer Then

'
' Declares etc. used for API Timer.
'
Private Declare Function SetTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimetFunc As Long) As Long
Private Declare Function KillTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long) As Long

Private Const m_conTimerID = 12345  ' We use this ID.

Private m_conLngTimerID As Long     ' Timer ID.
Private m_lngInterval As Long       ' Timer Interval.
Private m_blnTimeEnabled As Boolean ' Timer running?

Public Sub TimerFunc(lngWndID As Long, msg As Long, lngEventID As Long, lngSysTime As Long)
    Call frmMain.FireTimer  ' Specify the FIRE event here!
End Sub

Public Sub SetInterval(lngInterval As Long)
    m_lngInterval = lngInterval
    Call DeleteTimer
    Call CreateTimer
End Sub

Public Function GetInterval() As Long
    GetInterval = m_lngInterval
End Function

Public Sub EnableTimer()
    m_blnTimeEnabled = True
    Call DeleteTimer
    Call CreateTimer
End Sub

Public Sub DisableTimer()
    m_blnTimeEnabled = False
    Call DeleteTimer
End Sub

Public Sub DeleteTimer()
    If m_conLngTimerID <> 0 Then Call KillTimer(frmMain.hwnd, m_conTimerID)
    m_conLngTimerID = 0
End Sub

Public Sub CreateTimer()
    m_conLngTimerID = SetTimer(frmMain.hwnd, m_conTimerID, m_lngInterval, AddressOf TimerFunc)
End Sub

Public Function TimerIsEnabled() As Boolean
    TimerIsEnabled = m_blnTimeEnabled
End Function

#End If
